<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/24/2009 *
 * ===================                          Last change: 11/24/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-grade.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Grades for your members                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einstufungen Ihrer Mitglieder                    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0.0');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0'));

// This extension is in development (non-productive)
enableExtensionProductive(false);

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// General and grade level data
		addDropTableSql('grade_data');
		addCreateTableSql('grade_data', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`grade_name` VARCHAR(255) NOT NULL DEFAULT '',
`grade_parent_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
PRIMARY KEY (`id`),
INDEX (`grade_parent_id`)
) TYPE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'Grade general data'");

		// Data for if a grade level has been reached
		addDropTableSql('grade_cash_data');
		addCreateTableSql('grade_cash_data', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`grade_cash_name` VARCHAR(255) NOT NULL DEFAULT '',
`grade_cash_type` ENUM('DISCOUNT','BONUS') NOT NULL DEFAULT 'DISCOUNT',
`reached_points` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`reached_mails` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`time_valid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
) TYPE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'Grade data if the grade have been \"cashed\"'");

		// Connection grade<->cash data
		addDropTableSql('grade_cash_connect');
		addCreateTableSql('grade_cash_conenct', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`grade_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`grade_cash_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
UNIQUE KEY `grade_cash` (`grade_id`,`grade_cash_id`),
INDEX (`grade_cash_id`)
) TYPE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'Grade<->cash data connection'");

		// Connection grade<->user data
		addDropTableSql('grade_user_connect');
		addCreateTableSql('grade_user_connect', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`grade_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`grade_expired TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
PRIMARY KEY (`id`),
UNIQUE KEY (`userid`,`grade_id`),
INDEX (`grade_id`)
) TYPE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'Grade<->user connection'");
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('grade_data');
		addDropTableSql('grade_cash_data');
		addDropTableSql('grade_cash_connect');
		addDropTableSql('grade_user_connect');
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
