<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-unlock_emails.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Unlock ordered emails                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Werbebuchungen freigeben                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Check for mails
$result_main = SQL_QUERY("SELECT
	`id`, `sender`, `subject`, `payment_id`, `timestamp`, `url`, `target_send`, `cat_id`
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`data_type`='ADMIN'
ORDER BY
	`timestamp` ASC", __FILE__, __LINE__);

if ((!SQL_HASZERONUMS($result_main)) || (isFormSent('lock'))) {
	if (isFormSent('accept')) {
		if (ifPostContainsSelections()) {
			// Accept mail orders
			foreach (postRequestParameter('sel') as $id => $value) {
				// Secure id number
				$id = bigintval($id);

				// Order placed in queue...
				$result = SQL_QUERY_ESC("SELECT
	po.`url`, po.`subject`, po.`sender`, pay.`payment`, po.`payment_id`
FROM
	`{?_MYSQL_PREFIX?}_pool` AS `po`
INNER JOIN
	`{?_MYSQL_PREFIX?}_payments` AS `pay`
ON
	po.`payment_id`=pay.`id`
WHERE
	po.`id`=%s
LIMIT 1",
					array($id), __FILE__, __LINE__);

				// Update wents fine?
				if (SQL_NUMROWS($result) == 1) {
					// Load data
					$content = SQL_FETCHARRAY($result);

					// Is the surfbar installed?
					// @TODO Rewrite these if-blocks to a filter
					if ((isExtensionActive('surfbar')) && (getConfig('surfbar_migrate_order') == 'Y')) {
						// Then "migrate" the URL to the surfbar
						SURFBAR_ADMIN_MIGRATE_URL($content['url'], $content['sender']);
					} // END - if

					// Check for bonus extension version >= 0.4.4 for the order bonus
					if ((isExtensionInstalledAndNewer('bonus', '0.4.4')) && (isBonusRallyeActive())) {
						// Add points directly
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `bonus_order`=`bonus_order`+{?bonus_order?} WHERE `userid`=%s LIMIT 1",
							array(bigintval($content['sender'])), __FILE__, __LINE__);

						// Subtract bonus points from system
						handleBonusPoints(getConfig('bonus_order'));
					} // END - if

					// Load email template
					$message_user = loadEmailTemplate('member_order_accepted', $content, $content['sender']);

					// Send email
					sendEmail($content['sender'], '{--MEMBER_ORDER_ACCEPTED--}', $message_user);

					// Unlock selected email
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='NEW' WHERE `id`=%s AND `data_type`='ADMIN' LIMIT 1",
						array($id), __FILE__, __LINE__);
				} // END - if

				// Free result
				SQL_FREERESULT($result);
			} // END - foreach

			// Set message
			$message = '{--ADMIN_MAILS_ACTIVATED--}';
		} else {
			// Nothing checked!
			$message = '{--ADMIN_MAILS_NOTHING_CHECKED--}';
		}

		// Mails unlocked for mail delivery
		displayMessage($message);
	} elseif (isPostRequestParameterSet('reject')) {
		if (ifPostContainsSelections()) {
			// Reject mail orders
			$OUT = '';
			foreach (postRequestParameter('sel') as $id => $value) {
				// Secure id number
				$id = bigintval($id);

				// Load URL and subject from pool
				$result = SQL_QUERY_ESC("SELECT `url`, `subject`, `sender` FROM `{?_MYSQL_PREFIX?}_pool` WHERE `id`=%s LIMIT 1",
					array($id), __FILE__, __LINE__);

				// Load data
				$content = SQL_FETCHARRAY($result);

				// Free result
				SQL_FREERESULT($result);

				// Load email template and send it away
				$message_user = loadEmailTemplate('member_order_rejected', $content, $content['sender']);
				sendEmail($content['sender'], '{--MEMBER_ORDER_REJECTED--}', $message_user);

				// If you do not enter an URL to redirect to, your URL will be set!
				if ((!isPostRequestParameterSet('redirect')) || (postRequestParameter('redirect') == 'http://')) {
					setPostRequestParameter('redirect', getUrl());
				} // END - if

				// Redirect URL
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `url`='%s', `data_type`='NEW' WHERE `id`=%s LIMIT 1",
					array(postRequestParameter('redirect'), $id),__FILE__, __LINE__);

				// Prepare data for the row template
				$content = array(
					'id'  => $id,
					'url' => postRequestParameter('url', $id),
				);

				// Load row template and switch colors
				$OUT .= loadTemplate('admin_unlock_emails_redir_row', true, $content);
			} // END - foreach

			// Load main template
			loadTemplate('admin_unlock_emails_redir', false, $OUT);
		} else {
			// Nothing selected
			displayMessage('{--ADMIN_MAILS_NOTHING_CHECKED--}');
		}
	} elseif ((isFormSent('lock')) && (ifPostContainsSelections()) && (isUrlBlacklistEnabled())) {
		// Lock URLs
		foreach (postRequestParameter('sel') as $id => $url) {
			// Secure id number
			$id = bigintval($id);

			// Lookup in blacklist
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_url_blacklist` WHERE `url`='%s' LIMIT 1",
				array($url), __FILE__, __LINE__);
			if (SQL_HASZERONUMS($result)) {
				// Did not find a record so we can add it... :)
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_url_blacklist` (`url`,`pool_id`) VALUES ('%s',%s)",
					array($url, $id), __FILE__, __LINE__);
			} // END - if

			// Free memory
			SQL_FREERESULT($result);
		} // END - foreach

		// Output message
		displayMessage('{--ADMIN_URLS_BLOCKED--}');
	} elseif ((!isFormSent('lock')) && (!isFormSent('accept')) && (!isFormSent('reject'))) {
		// Mail orders are in pool so we can display them
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result_main)) {
			// Prepare data for the template
			$content['timestamp'] = generateDateTime($content['timestamp'], 2);

			// Load row template and switch colors
			$OUT .= loadTemplate('admin_unlock_emails_row', true, $content);
		} // END - while

		// Free memory
		SQL_FREERESULT($result_main);

		// Remember in array
		$content['rows'] = $OUT;

		// Load main template
		loadTemplate('admin_unlock_emails', false, $content);
	} elseif ((isFormSent('lock')) && (!isUrlBlacklistEnabled())) {
		// URL blacklist not activated
		displayMessage('{--ADMIN_URL_BLACKLIST_DISABLED--}');
	} else {
		// Wrong call!
		displayMessage('{--ADMIN_WRONG_CALL--}');
	}
} else {
	// No mail orders fond
	displayMessage('{--ADMIN_NO_MAILS_IN_POOL--}');
}

// [EOF]
?>
