<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/25/2003 *
 * ===================                          Last change: 11/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : index.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Index page. A simple redirection to modules.php  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Index-Seite. Eine simple Weiterleitung auf die   *
 *           modules.php                                                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// XDEBUG call
//* DEBUG: */ xdebug_start_trace();

// Load security stuff here
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Set module/what
$GLOBALS['module'] = 'index';
$GLOBALS['what'] = 'index';

// Set CSS mode
$GLOBALS['output_mode'] = '0';

// Load config.php
require('inc/config-global.php');

// Set content type
setContentType('text/html');

// Check for cookies
if ((isSessionVariableSet('visited')) || (getConfig('index_delay') > -1)) {
	// Header
	loadIncludeOnce('inc/header.php');

	// Is the index page configured for redirect pr not?
	if (getConfig('index_cookie') > 0) {
		// Set cookie and remeber it for specified time
		setSession('visited', 'true');
	} elseif (isSessionVariableSet('visited')) {
		// Remove cookie when admin set 0 in setup
		setSession('visited', '');
	}

	// Template laden
	loadTemplate('index');

	// Shall I insert an automated forward?
	if (getConfig('index_delay') > 0) {
		// This will be a JavaScript-redirect!
		$content['delay']  = (getConfig('index_delay') * 1000 + 500);
		$content['module'] = 'index';

		// Load template
		loadTemplate('index_forward', false, $content);
	} // END - if

	// Footer
	loadIncludeOnce('inc/footer.php');
} else {
	// Redirect to main page
	redirectToUrl('modules.php?module=index');
}

// [EOF]
?>
